//------------------------------------------------------------------
#property copyright "www.forex-tsd.com" 
#property link      "www.forex-tsd.com" 
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  LawnGreen
#property indicator_color2  Green
#property indicator_color3  Red
#property indicator_color4  Crimson
#property indicator_width1, 2
#property indicator_width3, 2
#property indicator_minimum 0
#property indicator_maximum 1
//
//
//
//
//

extern double AccStep         = 0.008;
extern double AccLimit        = 0.9;
extern int    PriceHigh       = PRICE_CLOSE;
extern int    PriceLow        = PRICE_CLOSE;
extern int    FastEma         = 5;
extern int    FastEmaPrice    = PRICE_CLOSE;
extern int    SlowEma         = 20;
extern int    SlowEmaPrice    = PRICE_CLOSE;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

double sarUpa[];
double sarUpb[];
double sarDna[];
double sarDnb[];
double state[];
double ematr[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
      SetIndexBuffer(0,sarUpa); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,sarUpb); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,sarDna); SetIndexStyle(2,DRAW_HISTOGRAM);
      SetIndexBuffer(3,sarDnb); SetIndexStyle(3,DRAW_HISTOGRAM);
      SetIndexBuffer(4,state); 
      SetIndexBuffer(5,ematr); 
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
    
   for(int i = limit; i >= 0; i--)
   {
      double sarClose;
      double sarOpen;
      double sarPosition;
      double sarChange;
      double emaf  = iMA(NULL,0,FastEma,0,MODE_EMA,FastEmaPrice,i);
      double emas  = iMA(NULL,0,SlowEma,0,MODE_EMA,SlowEmaPrice,i);
      double pHigh = iMA(NULL,0,6,0,MODE_LWMA,PriceHigh,i);
      double pLow  = iMA(NULL,0,6,0,MODE_LWMA,PriceLow ,i);
         iParabolic(MathMax(pHigh,pLow),MathMin(pHigh,pLow),AccStep,AccLimit,sarClose,sarOpen,sarPosition,sarChange,i);
         sarUpa[i] = EMPTY_VALUE;
         sarUpb[i] = EMPTY_VALUE;
         sarDna[i] = EMPTY_VALUE;
         sarDnb[i] = EMPTY_VALUE;
         state[i]  = state[i+1];
         ematr[i]  = ematr[i+1];
            if (emaf>emas) ematr[i] =  1;
            if (emaf<emas) ematr[i] = -1;
            if (ematr[i]!= ematr[i+1] && sarChange!=0)
            {
               if (ematr[i]==-1 && sarChange==-1) state[i] = -2;
               if (ematr[i]== 1 && sarChange== 1) state[i] =  2;
            }
            else
            {
               if (ematr[i]==-1 && sarPosition==1) state[i] =-1;
               if (ematr[i]== 1 && sarPosition==1) state[i] = 1;
            }
            if (state[i] == 1) sarUpa[i] = 1;
            if (state[i] == 2) sarUpb[i] = 1;
            if (state[i] ==-1) sarDna[i] = 1;
            if (state[i] ==-2) sarDnb[i] = 1;
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workSar[][7];
#define _high     0
#define _low      1
#define _ohigh    2
#define _olow     3
#define _open     4
#define _position 5
#define _af       6

void iParabolic(double high, double low, double step, double limit, double& pClose, double& pOpen, double& pPosition, double& pChange, int i)
{
   if (ArrayRange(workSar,0)!=Bars) ArrayResize(workSar,Bars); i = Bars-i-1;
   
   //
   //
   //
   //
   //
   
      pChange = 0;
         workSar[i][_ohigh] = high;
         workSar[i][_olow]  = low;
            if (i<1)
               {
                  workSar[i][_high]     = high;
                  workSar[i][_low]      = low;
                  workSar[i][_open]     = high;
                  workSar[i][_position] = -1;
                  return;
               }
         workSar[i][_open]     = workSar[i-1][_open];
         workSar[i][_af]       = workSar[i-1][_af];
         workSar[i][_position] = workSar[i-1][_position];
         workSar[i][_high]     = MathMax(workSar[i-1][_high],high);
         workSar[i][_low]      = MathMin(workSar[i-1][_low] ,low );
      
   //
   //
   //
   //
   //
            
   if (workSar[i][_position] == 1)
      if (low<=workSar[i][_open])
         {
            workSar[i][_position] = -1;
               pChange = -1;
               pClose  = workSar[i][_high];
                         workSar[i][_high] = high;
                         workSar[i][_low]  = low;
                         workSar[i][_af]   = step;
                         workSar[i][_open] = pClose + workSar[i][_af]*(workSar[i][_low]-pClose);
                            if (workSar[i][_open]<workSar[i  ][_ohigh]) workSar[i][_open] = workSar[i  ][_ohigh];
                            if (workSar[i][_open]<workSar[i-1][_ohigh]) workSar[i][_open] = workSar[i-1][_ohigh];
         }
      else
         {
               pClose = workSar[i][_open];
                    if (workSar[i][_high]>workSar[i-1][_high] && workSar[i][_af]<limit) workSar[i][_af] = MathMin(workSar[i][_af]+step,limit);
                        workSar[i][_open] = pClose + workSar[i][_af]*(workSar[i][_high]-pClose);
                            if (workSar[i][_open]>workSar[i  ][_olow]) workSar[i][_open] = workSar[i  ][_olow];
                            if (workSar[i][_open]>workSar[i-1][_olow]) workSar[i][_open] = workSar[i-1][_olow];
         }
   else
      if (high>=workSar[i][_open])
         {
            workSar[i][_position] = 1;
               pChange = 1;
               pClose  = workSar[i][_low];
                         workSar[i][_low]  = low;
                         workSar[i][_high] = high;
                         workSar[i][_af]   = step;
                         workSar[i][_open] = pClose + workSar[i][_af]*(workSar[i][_high]-pClose);
                            if (workSar[i][_open]>workSar[i  ][_olow]) workSar[i][_open] = workSar[i  ][_olow];
                            if (workSar[i][_open]>workSar[i-1][_olow]) workSar[i][_open] = workSar[i-1][_olow];
         }
      else
         {
               pClose = workSar[i][_open];
               if (workSar[i][_low]<workSar[i-1][_low] && workSar[i][_af]<limit) workSar[i][_af] = MathMin(workSar[i][_af]+step,limit);
                   workSar[i][_open] = pClose + workSar[i][_af]*(workSar[i][_low]-pClose);
                            if (workSar[i][_open]<workSar[i  ][_ohigh]) workSar[i][_open] = workSar[i  ][_ohigh];
                            if (workSar[i][_open]<workSar[i-1][_ohigh]) workSar[i][_open] = workSar[i-1][_ohigh];
         }

   //
   //
   //
   //
   //
   
   pOpen     = workSar[i][_open];
   pPosition = workSar[i][_position];
}